<div class="modal fade right" id="sidebar-right" tabindex="-1" role="dialog">
  <div class="modal-dialog modal-full-height modal-lg  modal-right" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" id="modal-close" data-dismiss="modal" (click)="closeAssetPopup()"><span aria-hidden="true">&times;</span></button>
        <h4 class="modal-title uppercase" *ngIf="assetData && assetData.assetType">Asset</h4>
        <h4 class="modal-title uppercase" *ngIf="assetData && assetData.serviceType">Service</h4>
      </div>
      <div class="modal-body">
        <div class="row">
          <div class="col-sm-12 col-md-6 col-lg-6 col-xl-6">
            <app-asset-card *ngIf="assetData && assetData.assetType" [assetData]="assetData" [isCardHeightFixed]="true" [showCloseBtn]="false" [showLinkBtn]="false"
                            [isLinkable]="false" [isCardClickable]="false" [showGroupBtn]="true" [upadtedCartSpecificDetails]="assetUpdatedData"
                            [assetConfigDetails]="assetConfigDetails" [serviceAssetConfigDetails]="serviceAssetConfigDetails"
                            [resetFormData]="resetFormData" [config]="assetConfigDetails" [showStatusOnAssetCard]="showStatusOnAssetCard"
            ></app-asset-card>
            <app-asset-card *ngIf="assetData && assetData.serviceType" [assetData]="assetData" [isCardHeightFixed]="true" [showCloseBtn]="false" [showLinkBtn]="false"
                            [isLinkable]="false" [isCardClickable]="false" [showGroupBtn]="true" [upadtedCartSpecificDetails]="assetUpdatedData"
                            [assetConfigDetails]="assetConfigDetails" [serviceAssetConfigDetails]="serviceAssetConfigDetails"
                            [resetFormData]="resetFormData" [config]="serviceAssetConfigDetails" [showStatusOnAssetCard]="showStatusOnAssetCard"
            ></app-asset-card>
          </div>
        </div>

          <div class="tab right-slider-tabs">

            <!--Common-->
            <button class="tablinks defaultTab" (click)="openTabContent($event, 'assetInfo')" [ngClass]="{'active' : true}">{{infoLabel}}</button>

            <!--buttons for Service-->
            <button class="tablinks linkTab" (click)="openTabContent($event, 'link')" *ngIf="assetData && assetData.serviceType && isAssetLinkable
            && SUBJECT.ASSET|can:ACTIONS.READ">Link</button>
            <button class="tablinks serviceManageTab" (click)="openTabContent($event, 'manageService')" *ngIf="assetData && assetData.serviceType &&
            isServiceManageable && SUBJECT.SERVICE|can:ACTIONS.WRITE">Manage</button>

            <!--buttons for Assets-->
            <button class="tablinks linkTab" (click)="openTabContent($event, 'link')" *ngIf="assetData && assetData.assetType && isAssetLinkable &&
            SUBJECT.ASSET|can:ACTIONS.READ">Link</button>
            <button class="tablinks serviceTab" (click)="openTabContent($event, 'service')" *ngIf="assetData && assetData.assetType &&
            isServiceLinkable && SUBJECT.SERVICE|can:ACTIONS.READ">Service</button>
            <!--<button class="tablinks serviceManageTab" (click)="openTabContent($event, 'manageService')" *ngIf="assetData && assetData.assetType &&
            isServiceManageable && SUBJECT.SERVICE|can:ACTIONS.WRITE">Manage</button>-->
            <button class="tablinks statusTab" (click)="openTabContent($event, 'status'); getServerAnalytics(); showStatsGraphTabs = false" *ngIf="showStatus">Stats</button>
          </div>

          <div  id="assetInfo" class="tabcontent" style="display: block">

            <!--edit button for Asset-->
              <div class="plusIcon" id="edit-asset-form" (click)="editOptionClicked()"
                   *ngIf="assetData && assetData.assetType && (!isAssetDetailsInReadMode && assetFromConfig.length > 0 ) && SUBJECT.ASSET | can:ACTIONS.UPDATE">
                <a href="#" onclick="return false;" data-toggle="tooltip" data-placement="top" matTooltip="Edit" matTooltipPosition="before" class="btn-floating btn-lg waves-effect waves-light plus">
                  <i class="fa fa-pen"></i></a>
              </div>

            <!--edit button for Service-->
            <div class="plusIcon" id="edit-service-form" (click)="editOptionClicked()"
                 *ngIf="assetData && assetData.serviceType && (!isAssetDetailsInReadMode && assetFromConfig.length > 0 ) && SUBJECT.SERVICE | can:ACTIONS.UPDATE">
              <a href="#" onclick="return false;" data-toggle="tooltip" data-placement="top" matTooltip="Edit" matTooltipPosition="before" class="btn-floating btn-lg waves-effect waves-light plus">
                <i class="fa fa-pen"></i></a>
            </div>


              <app-asset-edit-from [resetFormData]="resetFormData" [isEditOptionClicked]="isEditOptionClicked" [formConfigData]="assetFromConfig"
                                   [assetData]="assetData" [assetId]="assetId" (deregisterAsset)="deregisterAsset($event)"
                                   (updateAssetCart)="updateAssetCart($event)"></app-asset-edit-from>
          </div>

          <div id="link" class="tabcontent" *ngIf="isAssetLinkable">
            <div class="plusIcon" id="asset-list-plus" (click)="resetSearchedAssets()" *ngIf="assetData && assetData.assetType && !isAssetDetailsInReadMode
            && SUBJECT.ASSET|can:ACTIONS.UPDATE ">
                <a href="#" onclick="return false;" data-toggle="tooltip" data-placement="top" matTooltip="Asset linking" matTooltipPosition="before" class="btn-floating btn-lg waves-effect waves-light plus"><i class="fa fa-plus"></i></a>
              </div>
            <div class="plusIcon" id="asset-list-plus" (click)="resetSearchedAssets()" *ngIf="assetData && assetData.serviceType && !isAssetDetailsInReadMode
            && SUBJECT.SERVICE|can:ACTIONS.UPDATE ">
              <a href="#" onclick="return false;" data-toggle="tooltip" data-placement="top" matTooltip="Asset linking" matTooltipPosition="before" class="btn-floating btn-lg waves-effect waves-light plus"><i class="fa fa-plus"></i></a>
            </div>
            <mat-accordion>
              <mat-expansion-panel *ngFor="let assetDetails of individualAssetLinkedDetailsArray">
                <mat-expansion-panel-header [collapsedHeight]="customCollapsedHeight" [expandedHeight]="customExpandedHeight">
                  <mat-panel-title class="groupBadgeTitle">
                    <a data-toggle="collapse" href="#{{assetDetails.assetType}}"  aria-expanded="false" aria-controls="{{assetDetails.assetType}}">
                      <button mat-raised-button color="primary" class="groupBadge uppercase">{{assetDetails.assetType}} <span class="badge">{{assetDetails.count}}</span></button>
                    </a>
                  </mat-panel-title>
                  <mat-panel-description></mat-panel-description>
                </mat-expansion-panel-header>
                <div class="row">
                  <div class="col-md-6" *ngFor="let linkedAsset of assetDetails.assetsLinked">
                    <mat-card class="asset-mat-card">
                      <app-asset-card [assetData]="linkedAsset" [showCloseBtn]="isAssetDelinkBtnReqired()" [isCardClickable]="false" [showGroupBtn]="true"
                                      [assetConfigDetails]="assetConfigDetails" [isAssetDetailsInReadMode]="isAssetDetailsInReadMode"
                                      [showStatusOnAssetCard]="showStatusOnAssetCard" (delinkAssetDetails)="assetDetailsToDelink($event)"
                                      [config]="assetConfigDetails"></app-asset-card>
                    </mat-card>
                  </div>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
            <div>
              <h3 class="asset-not-found" *ngIf="individualAssetLinkedDetailsArray.length === 0">
                <span>&ldquo;</span>No Assets Linked<span>&rdquo;</span>
              </h3>
            </div>
            <app-assets-for-linking [allAssetTypes]="assetConfig" [config]="assetConfigDetails" [assetData]="assetData" (linkAssetDetailsToSlider)="assetDetailsToLink($event)"
                                    [resetSearchedAssetOnPlusClick]="resetSearchedAssetOnPlusClick"></app-assets-for-linking>
          </div>

          <div id="service" class="tabcontent" *ngIf="isServiceLinkable">
            <div class="plusIcon" id="service-list-plus" (click)="resetSearchedServices()" *ngIf="!isAssetDetailsInReadMode && SUBJECT.SERVICE|can:ACTIONS.WRITE">
                <a href="#" onclick="return false;" data-toggle="tooltip" data-placement="top" matTooltip="Service linking" matTooltipPosition="before" class="btn-floating btn-lg waves-effect waves-light plus"><i class="fa fa-plus"></i></a>
            </div>
            <mat-accordion>
              <mat-expansion-panel *ngFor="let serviceDetails of individualAssetLinkedDetailsArray">
                <mat-expansion-panel-header [collapsedHeight]="customCollapsedHeight" [expandedHeight]="customExpandedHeight">
                  <mat-panel-title class="groupBadgeTitle">
                    <a data-toggle="collapse" href="#{{serviceDetails.assetType}}"  aria-expanded="false" aria-controls="{{serviceDetails.assetType}}">
                      <button mat-raised-button color="primary" class="uppercase groupBadge">{{serviceDetails.assetType}} <span class="badge">{{serviceDetails.count}}</span></button>
                    </a>
                  </mat-panel-title>
                  <mat-panel-description></mat-panel-description>
                </mat-expansion-panel-header>
                <div class="row">
                  <div class="col-md-6" *ngFor="let linkedService of serviceDetails.assetsLinked">
                    <mat-card class="asset-mat-card">
                      <app-asset-card [assetData]="linkedService" [showCloseBtn]="false" [isCardClickable]="false" [showGroupBtn]="true" [showDelinkServiceBtn]="isServiceDelinkBtnReqired()"
                                      [assetConfigDetails]="assetConfigDetails" [serviceAssetConfigDetails]="serviceAssetConfigDetails" [isAssetDetailsInReadMode]="isAssetDetailsInReadMode"
                                      [showStatusOnAssetCard]="showStatusOnAssetCard" (delinkServiceDetails)="serviceDetailsToDelink($event)"
                                      [config]="serviceAssetConfigDetails"></app-asset-card>
                    </mat-card>
                  </div>
                </div>
              </mat-expansion-panel>
            </mat-accordion>
            <div>
              <h3 class="asset-not-found" *ngIf="individualAssetLinkedDetailsArray.length === 0">
                <span>&ldquo;</span>No Services Linked<span>&rdquo;</span>
              </h3>
            </div>
             <app-services-for-linking [serviceAssetConfigDetails]="serviceAssetConfigDetails" [config]="serviceAssetConfigDetails" [assetData]="assetData" (linkAssetDetailsToSlider)="serviceDetailsToLinkAsset($event)"
                                       [resetSearchedServicesOnPlusClick]="resetSearchedServicesOnPlusClick"></app-services-for-linking>
          </div>

          <div id="manageService" class="tabcontent" *ngIf="isServiceManageable">
              <span *ngIf="serviceActionsArray.length > 0">
                <button mat-raised-button [color]="action.value === 'start' ? 'primary' : action.value === 'stop' ? 'warn' : action.value === 'restart' ? 'accent' : ''" class='MR10 showServerActionBtn'
                        *ngFor="let action of serviceActionsArray" (click)="manageServices(action)">{{action.label}}</button>
              </span>
            <div>
              <h3 class="asset-not-found" *ngIf="!isServerAvailable">
                <span>&ldquo;</span>Currently server unavailable<span>&rdquo;</span>
              </h3>
            </div>
          </div>

          <div id="status" class="tabcontent" *ngIf="showStatus">
            <div class="plusIcon">
              <a href="#" onclick="return false;" (click)="getServerAnalytics(); showStatsGraphTabs = false" matTooltip="Refresh" matTooltipPosition="before" class="btn-floating btn-lg waves-effect waves-light plus">
                <i class="zmdi zmdi-refresh" style="font-size: 24px"></i></a>
            </div>

            <div *ngIf="statsNotFound">
              <h3 class="asset-not-found">
                <span>&ldquo;</span>Currently server stats unavailable<span>&rdquo;</span>
              </h3>
            </div>

            <app-system-stats-graph [graphData]="graphData['disk']" [resetFormData]="resetFormData" [showTabs]="showStatsGraphTabs"
                                    [graphRandomNumber]="graphDiskRandomNumber" (graphDataWithSeriesType)="getGraphDataForSeriesType($event)"
                                    [canvasId]="'diskStatsChart'"></app-system-stats-graph>

            <app-system-stats-graph [graphData]="graphData['cpu']" [resetFormData]="resetFormData" [showTabs]="showStatsGraphTabs"
                                    [graphRandomNumber]="graphCpuRandomNumber" (graphDataWithSeriesType)="getGraphDataForSeriesType($event)"
                                    [canvasId]="'cpuStatsChart'"></app-system-stats-graph>

            <app-system-stats-graph [graphData]="graphData['memory']" [resetFormData]="resetFormData" [showTabs]="showStatsGraphTabs"
                                    [graphRandomNumber]="graphMemoryRandomNumber" (graphDataWithSeriesType)="getGraphDataForSeriesType($event)"
                                    [canvasId]="'memoryStatsChart'"></app-system-stats-graph>
          </div>
      </div>

      <div *ngIf="showCircularLoader">
        <app-circular-loader></app-circular-loader>
      </div>

    </div>
  </div>
</div>
